<template>
  <crud-data-table-update
    :item="value"
    @onSave="onSave(value)"
    @emitTheValueBeforeEditOnClose="emitValueToParent"
  >
    {{ value | formatMonth }}
    <template v-slot:dialog>
      <v-form
        ref="form"
        @submit.prevent
      >
        <raw-date-picker-single-field
          :value="value"
          type="month"
          class="mt-3"
          :min="minDate"
          :max="maxDate"
          @input="emitValueToParent"
        />
      </v-form>
    </template>
  </crud-data-table-update>
</template>

<script>
  import DatesMixin from '@/mixins/date'

  export default {
    name: 'EditReferenceMonthDialog',
    mixins: [DatesMixin],
    inheritAttrs: false,
    props: {
      value: String,
      itemId: {
        type: Number,
        required: true,
      },
      minDate: {
        type: String,
        required: true,
      },
      maxDate: {
        type: String,
        required: true,
      },
    },
    methods: {
      onSave (referenceMonth) {
        if (this.$refs.form.validate()) {
          this.$store.dispatch('incomeAmounts/updateIncomeAmountReferenceMonth', {
            ID: this.itemId,
            referenceMonth,
          })
            .then(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'success',
                text: this.$t('updateSuccess'),
              })
            })
            .catch(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'error',
                text: this.$t('updateError'),
              })
            })
        }
      },
      emitValueToParent (event) {
        this.$emit('input', event)
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          updateSuccess: 'Mês de referência atualizado com sucesso!',
          updateError: 'Ops... Algo deu errado ao tentar atualizar o mês de referência. Por favor, tente novamente.',
        },
        'en-US': {
          updateSuccess: 'Reference month successfully updated!',
          updateError: 'Oops... Something went wrong while trying to update the reference month. Please try again.',
        },
      },
    },
  }
</script>
